(* IMPLEMENTATION *) MODULE Mousy;
(*$T-,$S-,$Q+                                     .
    1987-2017 ari.tao  * 24.10.87 ++ 4.2.90 ~ 9.9.97

   Speedy-Mouse
     Runs as an ACC under SingleTOS or else as a .TOS from the desktop or
       as an appointed auto-start .PRG (ie. as TSR, but _not_ in the AUTO!).

   (mit Mini-GEMX linken!): *)
IMPORT GEMX, GDB, Mini;
(**)
FROM   SYSTEM  IMPORT ADR, CODE;
IMPORT BIOX, (* AEB,*) SX;

CONST  TITLE = "  Speedy Mouse ";
       NOI   = " already installed? ";  (* 30! --v *)
       CRITE =                  "  '97 Niki Naus ";
(*
CONST  MD0 = "[2][ |             ";
       MD1 = CRITE;
       MD2 =    "| |      ";
       MD3 = TITLE;
       MD4 = "][  <  |   ";
       MD5 = " 3    |  >  ]";
VAR    AlD:  ARRAY [0..160] OF CHAR;
*)
CONST  PUSH = 48E7H (* MOVEM.L registers,-(SP) *);
       PULL = 4CDFH (* MOVEM.L (SP)+,registers *);
       A0A4 = 2848H (* MOVEA.L A0,A4 *);
       RTS  = 4E75H;
       sMUS = 734D5553H (*="sMUS"*);

VAR    activ:    BOOLEAN;
       pKBVec:   BIOX.KbdVecsPtr;
       xMUS:     BIOX.xBRA;
       Speed:    CARDINAL;
       dx,dy,pp: INTEGER;

TYPE   MPackPtr = POINTER TO RECORD ButtonState, dX,dY: CHAR END;

VAR  pPack: MPackPtr (* dummy! *);
PROCEDURE MouseMove; (*$P- nackt.*)
(* Der MouseVec wird vom XBIOS aufgerufen, wenn ein MouseMove-Package vom
   Keyboard ankam. Dann zeigt Register a0 auf ein Package von 3 Bytes:
         0: ButtonState (li = Bit 0, re = Bit 1)
         1: dX-Move (rel. zur letzten Pos., -128..127, i.d.Regel -7..7)
         2: dY-Move ( "    "     "     "        "          "       "  )
   Bem.: Es ist sehr wichtig,  da diese Routine mglichst kurz & schnell
   ist, da sonst eine berlastung des VBI auftreten kann. Sie uert sich
   durch 'Wegbrechen' des Cursors, spontane Key-Events (1111...) in Edit-
   Feldern und/oder Dauer-Refresh eines Desktop-Fensters (samt FAT-Lesen).
*) BEGIN CODE (PUSH, {10, 3}) (* save A4,D5 *);
    WITH pPack^ DO CODE (A0A4) (* nachtrglich! *);
      IF ((dX > 1c) & (dX < 377c)) OR ((dY > 1c) & (dY < 377c)) THEN
              dx := ORD (dX); IF (dx > 127) THEN DEC (dx, 256) END;
              dy := ORD (dY); IF (dy > 127) THEN DEC (dy, 256) END;
         IF (Speed < 4) THEN (* v- schneller als Mult. mit 3 bzw. 5.*)
              dX := CHR (dx *4 -dx); dY := CHR (dy *4 -dy);
         ELSE dX := CHR (dx *4 +dx); dY := CHR (dy *4 +dy); END END END;
    xMUS.OldVec;
    CODE (PULL, {5, 12}) (* redo D5,A4 *);
    CODE (RTS); END MouseMove; (*$P+*)

PROCEDURE Install (S: CARDINAL);
   VAR eP: LONGCARD;
 BEGIN Speed := S;
   WITH pKBVec^ DO
     IF BIOX.InqVec (ADR (MouseVec), eP, xMUS) & (xMUS.Ident = sMUS)
        OR activ OR (2 > S) THEN RETURN END; (* Nicht unntig installiern.*)
     MouseVec := PROC (BIOX.xSet (sMUS, MouseVec, MouseMove, xMUS));
     activ := TRUE; END (*W*); END Install;

PROCEDURE Remove;
 BEGIN activ := FALSE;
   BIOX.RemVec (ADR (pKBVec^.MouseVec), sMUS, 0) END Remove;

PROCEDURE Init;
 BEGIN pKBVec := BIOX.KbdBase ();                     (* -> Interrupt-Hdl.*)
(* AlD := MD5;
   Speed := ORD (AlD[1]) - ORD ('0');               (* Ermglicht Patchen.*)
   IF ~ (Speed IN {1,3,5}) THEN Speed := 3 END;
*) IF (BIOX.WMAX > 800) THEN Speed := 5 ELSE Speed := 3 END;
   activ := FALSE; END Init;

(*
PROCEDURE Dial;
  VAR   d: INTEGER;
 BEGIN  d := 0;
  WHILE d # 2 DO AlD[pp] := CHR (Speed+ ORD ('0'));
        d := AEB.FormAlert (2, AlD);
    IF (d = 1) THEN
      IF (Speed > 1) THEN DEC (Speed, 2) END;
      IF (Speed < 2) THEN Remove END; END (*I*);
    IF (d = 3) THEN
      IF (Speed < 5) THEN INC (Speed, 2); Install (Speed) END;
      END END (*I,W*) END Dial;

PROCEDURE DoAcc;
   VAR M: AEB.MsgPipeR;
 BEGIN AEB.VOID (AEB.MenuRegist (AEB.ApplInit(), TITLE));
       AlD := ""; SX.Sew (AlD, MD0,MD1,MD2,MD3,MD4,MD5);
       pp := SX.Pos (MD5, AlD, 0) +1;
   LOOP AEB.EventMessage (M); IF (M.Type = AEB.ACCOPEN) THEN Dial END END;
   END DoAcc;
*)

BEGIN Init; Install (Speed);
(*
      IF ~ GEMX.noAcc THEN DoAcc (*noEnd!*); RETURN END;
*)
      Mini.wT (15c); Mini.wT (TITLE); Mini.wT (CRITE);
      Mini.wT (15c); Mini.wT (12c);
      IF ~activ THEN Mini.wT (NOI)
      ELSE WITH GEMX.pBP^ DO GDB.Stay (0, HiTPA - LoTPA) END END;
      BIOX.Wait (70);
(**)  END Mousy.


DEFINITION MODULE Mousy;
(*  1990-98 ROLF SCHRADER. * 27.11.90 *)                 (* Maus-Speeder.*)

PROCEDURE Install (Speed: CARDINAL);    (* Nur 1,3,5. Im Body: Install(3).*)
PROCEDURE Dial;                       (* Interaktive Bestimmung von Speed.*)
PROCEDURE Remove;     (* Nach Benutzung des Moduls bei Prg.-Ende aufrufen.*)
END Mousy .

(* Lit.:
    F.Matthes:   "Der Maus auf die Sprnge geholfen", ST-Comp.10/87 S.48
    Ch.Siebert:  "Schlaues Muschen", c't 12/88 S.190
    St.Hhn:     "Heute schon gewrapt?", ST-Comp. 2/89 S.97
    J.Lietzow:   "Multi-Accessory", TOS 1/92 S.88
*)
